## Choose only on of the possible target types
# image=disk.img
# squash=rootfs.squash
raspi=oktopus.img

## Image size in MB. Needs to be able to hold all software.
imagesize=1792

## Additional packages
packages=python-tk,python-spidev,python-pygame,python-bluez,python-rpi.gpio,ckermit

## Debian release, so far only stretch has been tested
release=stretch

## Comma separated list of config modules from modules/ directory
modules=approx,remo2hbo,autoresize

## Hostname for the generated machine
hostname=oktopus

## Root password will be salted and encrypted in image
rootpass=plasmakocher

## The corresponding .pub file for the given rootkey will be applied as
## SSH login file for the root user.
## If the pub file is not found, a new key pair will be generated
# rootkey=image_ssh
rootkey=oktopus

## Comma separated list of users to be set up.
## User logins will start out with an empty password
## If the live module is in use, users will also be added to the sudo group
# users=adam,steve

## Wifi configuration, if a Wifi password is given, WPA encryption will be used
## without the password, the system will try to connect to an open wifi
#wifi=berlin.freifunk.net
# wifi=MyWiFi
# wifipass=P4ssW0rD
wifi="funky Kater"
wifipass="katerholzig"

## Timezone as offered by Debians tzdata selection
timezone=Europe/Berlin

## Comma separated list of locales, first one will become default locale
locales=en_US.UTF-8

## If nodm is installed, you can choose a user to login automatically
## If no user is given here, then nodm will default to root

## In nodm, use full screen chromium web browser as session
webui=http://localhost/

## When using NIS modules the directory server should be given
# nis_server=nismaster

## If the approxmodule is enabled, then one (and only one) apt-source
## can be choosen to install packages from
## See modules/approx.mk if you need more flexibility
# approx=http://localhost:9000/debian

.PHONY: _oktopus_maskjournal
_config: _oktopus_maskjournal ${CFGROOT}/opt/demo.py

img_mount/opt/demo.py: oktopus_raspberry/ ${CFGROOT}
	cp "$</demo3.py" "$@"
	cp "$</demo4.py" "$@"

oktopus_raspberry/:
	git clone https://git.tools.f4.htw-berlin.de/sliublin/oktopus_raspberry.git "$@"

_oktopus_maskjournal: ${CFGROOT}
	mkdir -p "$${CFGROOT}/etc/systemd/system/"
	ln -sf /dev/null "$${CFGROOT}/etc/systemd/system/systemd-journald.service"
	ln -sf /dev/null "$${CFGROOT}/etc/systemd/system/systemd-timesyncd.service"
